include:
  - remote: 'https://gitlab.com/systra/qeto/infra/gitlab-ci-templates/raw/master/python-ci.yml'
.type_checker_base:
  stage: test
  rules:
    - if: $CI_COMMIT_BRANCH
  script:
    - 'mkdir -p reports'
    - |
      set -e
      PRE=''
      [ -n "$WITH_PIPENV" ] && PRE='pipenv run' || true
      [ -n "$WITH_POETRY" ] && PRE='poetry run' || true
      $PRE mypy --exclude .cache --exclude .venv . | tee reports/mypy.log
  artifacts:
    when: on_failure
    paths:
      - reports/mypy.log
.type_checker_py313:
  extends:
    - .type_checker_base
    - .python_313
.type_checker_py312:
  extends:
    - .type_checker_base
    - .python_312
.type_checker_py311:
  extends:
    - .type_checker_base
    - .python_311
.type_checker_py310:
  extends:
    - .type_checker_base
    - .python_310
.type_checker_py39:
  extends:
    - .type_checker_base
    - .python_39
.type_checker_py38:
  extends:
    - .type_checker_base
    - .python_38
.type_checker_py37:
  extends:
    - .type_checker_base
    - .python_37
